# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`nvidia`](#nvidia): Installs the NVidia Drivers and CUDA.
* [`nvidia::cuda`](#nvidia--cuda): Installs nvidia's CUDA driver
* [`nvidia::driver`](#nvidia--driver): Installs the NVidia Driver.  Uses the graphics-driver ppa
* [`nvidia::overclock`](#nvidia--overclock): creates a script for overclocking the gpus.
* [`nvidia::xconfig`](#nvidia--xconfig): Configures the xserver generating xorg.conf

## Classes

### <a name="nvidia"></a>`nvidia`

Installs the NVidia Drivers and CUDA.

#### Parameters

The following parameters are available in the `nvidia` class:

* [`version`](#-nvidia--version)
* [`cuda_version`](#-nvidia--cuda_version)
* [`bashrc_file_path`](#-nvidia--bashrc_file_path)

##### <a name="-nvidia--version"></a>`version`

Data type: `String`

The version to install.

##### <a name="-nvidia--cuda_version"></a>`cuda_version`

Data type: `Optional[String]`

If this parmeter is set, will install cuda at the specified parameter.
@example '11-6'

Default value: `undef`

##### <a name="-nvidia--bashrc_file_path"></a>`bashrc_file_path`

Data type: `Optional[String]`

The path to the basrch file to update (uses concat).
If this parameter is set, will update the bashrc file with cuda environment variables.

Default value: `undef`

### <a name="nvidia--cuda"></a>`nvidia::cuda`

Installs nvidia's CUDA driver

#### Parameters

The following parameters are available in the `nvidia::cuda` class:

* [`version`](#-nvidia--cuda--version)
* [`bashrc_file_path`](#-nvidia--cuda--bashrc_file_path)

##### <a name="-nvidia--cuda--version"></a>`version`

Data type: `String`

The version of CUDA to install.

##### <a name="-nvidia--cuda--bashrc_file_path"></a>`bashrc_file_path`

Data type: `Optional[String]`

The path to the basrch file to update (uses concat).
If this parameter is set, will update the bashrc file with cuda environment variables.

Default value: `undef`

### <a name="nvidia--driver"></a>`nvidia::driver`

Installs the NVidia Driver.  Uses the graphics-driver ppa

#### Parameters

The following parameters are available in the `nvidia::driver` class:

* [`version`](#-nvidia--driver--version)

##### <a name="-nvidia--driver--version"></a>`version`

Data type: `String`

The version to install

### <a name="nvidia--overclock"></a>`nvidia::overclock`

creates a script for overclocking the gpus.

#### Parameters

The following parameters are available in the `nvidia::overclock` class:

* [`user`](#-nvidia--overclock--user)
* [`user_id`](#-nvidia--overclock--user_id)
* [`gpu_freq`](#-nvidia--overclock--gpu_freq)
* [`vram_freq`](#-nvidia--overclock--vram_freq)
* [`power_limit`](#-nvidia--overclock--power_limit)
* [`fan_speed`](#-nvidia--overclock--fan_speed)
* [`gpu_size`](#-nvidia--overclock--gpu_size)
* [`gpu_profiles`](#-nvidia--overclock--gpu_profiles)
* [`enable_service`](#-nvidia--overclock--enable_service)

##### <a name="-nvidia--overclock--user"></a>`user`

Data type: `String`

The user to assign ownership over the settings.

##### <a name="-nvidia--overclock--user_id"></a>`user_id`

Data type: `Integer`

The id of the user to run the overclock script (requires sudo access).

##### <a name="-nvidia--overclock--gpu_freq"></a>`gpu_freq`

Data type: `Integer`

Controls the GPUGraphicsClockOffset from nvidia-settings for the default GPU.

##### <a name="-nvidia--overclock--vram_freq"></a>`vram_freq`

Data type: `Integer`

Controls the GPUMemoryTransferRateOffset from nvidia-settings for each default GPU.
Note, GUI tools generally double the value you see when it is set via command line, so you may need to double this setting
for the desired result.

##### <a name="-nvidia--overclock--power_limit"></a>`power_limit`

Data type: `Integer`

Specifies maximum power limit in watts for the default GPU.

##### <a name="-nvidia--overclock--fan_speed"></a>`fan_speed`

Data type: `Integer`

The percentage to set the speed for all GPU Fans.

##### <a name="-nvidia--overclock--gpu_size"></a>`gpu_size`

Data type: `Integer`

The number of GPUs to control in the system.

Default value: `size($facts['gpus_pci_ids'])`

##### <a name="-nvidia--overclock--gpu_profiles"></a>`gpu_profiles`

Data type: `Optional[Hash]`

A hash with the name of the card specified with the following.
* 'id'            :
    'card name'   :
    'gpu_freq'    :
    'vram_freq'   :
    'power_limit' :

Default value: `undef`

##### <a name="-nvidia--overclock--enable_service"></a>`enable_service`

Data type: `Boolean`

Add overclock as a service to ensure overclock is called on boot.

Default value: `false`

### <a name="nvidia--xconfig"></a>`nvidia::xconfig`

Note, only creates the configuration if GPUs are detected through a custom fact.
Also, after this change, the system will need to be rebooted.

